<template>
  <PageContainer>
    <template slot="cp_search">
      <SearchPanel
        v-model="search"
        :columns="columns"
      />
    </template>
    <template slot="header">
      <MControlPanel
        state="list"
        :can-create="canCreate"
        @on-state-button-clicked="viewForm(null)"
        :actions="actions"
        :display.sync="display"
        :selected="selected">
      </MControlPanel>
    </template>

    <template slot="content" style="background-color: white">
      <MTable
        row-key="id"
        :data-source="items"
        :columns="columns"
        :display-view="display"
        :selected.sync="selected"
        :m-loading="loading"
        :m-filter="search"
        :pagination="pagination"
        @request="onRequest"
        @on-row-clicked="viewForm">
      </MTable>
    </template>
  </PageContainer>
</template>

<script>
import PageContainer from "components/PageContainer";
import MTable from "components/datatables/MTable";
import MControlPanel from "components/MControlPanel";
import {mapState} from "vuex";
import _get from 'lodash/get'
import SearchPanel from "components/datatables/SearchPanel";

export default {
  name: "OfficesIndex",

  components: {SearchPanel, MControlPanel, MTable, PageContainer},

  data() {
    return {
      search: null,
      pagination: {
        sortBy: 'created_at',
        descending: true,
        page: 1,
        rowsPerPage: 10,
      },
      columns: [
        {
          name: 'id', field: 'id', label: 'Id', align: 'left',
          sortable: true, searchable: true, type: 'number'
        },
        {
          name: 'slug', field: 'slug', label: 'Code', align: 'left',
          visible: true, sortable: true, searchable: true, type: 'text',
        },
        {
          name: 'name', field: 'name', label: 'Nom', align: 'left',
          visible: true, sortable: true, searchable: true, type: 'text',
        },
        {
          name: 'createdAt', field: row => this._formatDate(row.createdAt),
          sortable: true, label: 'Créé le', align: 'left', visible: false,
        },
      ],
      loading: false,
      actions: [],
      selected: [],
      grid: false,
      display: '',
    }
  },

  methods: {
    viewForm(row) {
      this.$router.push({
        path: `${this.baseUrl}/form/${row ? 'view' : 'create'}`,
        query: {id: _get(row, 'id')},
      })
    },

    async onRequest(props) {
      this.loading = true
      try {
        let results = await this.$store.dispatch('roles/index', props)
        this.pagination = {
          ...props.pagination,
          rowsNumber: parseInt(results.total),
        }
      } finally {
        this.loading = false
      }
    },
  },

  computed: {
    canCreate() {
      return true
    },
    canUpdate() {
      return true
    },
    ...mapState({
      items: state => _get(state, 'roles.items.data', []) || [],
      baseUrl: state => state.roles.baseUrl,
    })
  },

  async mounted() {
    await this.onRequest({
      pagination: this.pagination,
      filter: this.search,
    })

  },
}
</script>

<style scoped>

</style>
